log using pums90HSfinal4.log, replace

* copied from PUMS90b.do
clear
set more off
** pause on
** pause off
set mem 120m
do usa_00029.do
pause

tab sex raced

lab list  hispandlbl
*  0 Not Hispanic
keep if hispand == 0

tab yrimmig
* drop if yrimmig > 1979
drop if yrimmig >= 1980

drop  sex raced hispand

pause

 lab list gqtypelbl
/*
           0 NA (non-group quarters households)
           1 Institution (1990, 2000, ACS/PRCS)
           2 Correctional institutions
           3 Mental institutions
           4 Institutions for the elderly, handicapped, and poor
           5 Non-instutional GQ
           6 Military
           7 College dormitory
           8 Rooming house
           9 Other non-institutional GQ and unknown
*/
  drop if gqtype == 7
  drop if gqtype == 6
  drop if gqtype == 4
  drop if gqtype == 3
  drop if gqtype == 2
*  drop if gqtype == 1

 lab list  classwkrdlbl
/*
           0 N/A
          10 Self-employed
          11 Employer
          12 Working on own account
          13 Self-employed, not incorporated
          14 Self-employed, incorporated
          20 Works for wages
          21 Works on salary (1920)
          22 Wage/salary, private
          23 Wage/salary at non-profit
          24 Wage/salary, government
          25 Federal govt employee
          26 Armed forces
          27 State govt employee
          28 Local govt employee
          29 Unpaid family worker

*/
  drop if classwkrd == 26
*  drop if classwkrd == 29

lab list disabwrklbl
/*
           0 N/A
           1 No disability that affects work
           2 Disability limits but does not prevent work
           3 Disability prevents work
           4 Difficulty working
*/
*  keep if disabwrk == 1

lab list schoollbl
/*
           0 N/A
           1 No, not in school
           2 Yes, in school
           9 Missing
*/
  keep if school == 1

 lab list labforcelbl
/* Labor Force status in 1990 (earnings refer to 1989)
           0 N/A
           1 No, not in the labor force
           2 Yes, in the labor force
*/

count if age < 21

sum  incss,detail
drop if  incss>0
sum  incwelfr,detail
drop if  incwelfr>0
sum  incretir,detail
drop if  incretir>0



count
pause

gen einc0 =  incwage + max( incbus,0) + max( incfarm,0)
sum einc0,detail
count if einc0 == 0
 drop if einc0 == 0 &  wkswork1>0

count if einc0 == 0

count

cd \jw\data
rename statefip state

sort state
merge state using cola
drop _merge

* state    is the FIPS code

* count DC as part of MD (DC observations were dropped in X2)
replace state = 24  if state == 11

* deflate wages to 1983 dollars, then adjust for cost of living differences, by State
*  CWUR0000SA0 Consumer Price Index - Urban Wage Earners and Clerical Workers
scalar cpi79 =  73.1/100
scalar cpi89 = 122.6/100
scalar cpi07 = 2.04

gen rwage = einc0/cpi89
gen cwage = rwage/cola

compress
sort state age
save WM90PUMS19_25,replace

pause

lab list educdlbl

*          61 12th grade, no diploma
*          62 High school graduate or GED
*          63 Regular high school diploma
*          64 GED or alternative credential
*          65 Some college, but less than 1 year
*          70 1 year of college
*          71 1 or more years of college credit, no degree
*          80 2 years of college
*          81 Associate's degree, type not specified
*          82 Associate's degree, occupational program
*          83 Associate's degree, academic program
*          90 3 years of college
*         100 4 years of college
*         101 Bachelor's degree
*         110 5+ years of college
*         111 6 years of college (6+ in 1960-1970)
*         112 7 years of college
*         113 8+ years of college
*         114 Master's degree
*         115 Professional degree beyond a bachelor's degree
*         116 Doctoral degree

keep if educd == 62
keep if age < 21

count if wkswork1 == 1
count if incearn < 0

pause

* drop if incearn < 0

* drop people who did not work last year
* drop if wkswork1 == 1


set matsize 80
char age[omit] 20


drop if einc0 == 0

xi: qreg  cwage i.age i.state  
predict cwhat

drop _*

* put state names back in
* and omit 6 States with no home location observations
*  IDAHO, MAINE, NEW_HAMPSHIRE, NORTH_DAKOTA, RHODE_ISLAND, WYOMING 

sort state
merge state using ycolaWM50.dta
drop _merge

* statenum is the sequential code (1-50), merged in from ycolaWM50


pause

collapse statenum omit pop rwage cwhat (median) cwage  , by(state age)

pause

* this data file has state codes in sequence (not FIPS codes) 
outfile  statenum omit age pop staten cwhat using wmHS90f3.StateAge20.dat if age == 20, replace wide noquot

* this data file should be dropped (but the mbr85 program expects it)
outfile statenum age  cwhat using muHS90f.WM.nologAge20.dat if age == 20 ,replace noquot

sort state age
merge state using ycolaWM50, keep(Stcode)
drop _merge

rename cwhat cwhat90
rename cwage cwage90
rename rwage rwage90

save "WMHS90f.mu19_20.dta",replace


pause

log close
set more on

