FUNCTION Like_iw(obs_i)

! for mbr83W

use mbr_vars
IMPLICIT NONE

Interface
   FUNCTION alnorm( x, upper ) RESULT( fn_val )
     IMPLICIT NONE
     Double Precision, INTENT(IN)	::  x
     LOGICAL,   INTENT(IN)			::  upper
     Double Precision				::  fn_val
   end Function alnorm
end Interface

Integer , intent(in)               :: obs_i

Double Precision, parameter :: phi0 = 0.398942280444 ! 1/sqrt(2*Pi)

Double Precision :: Like_iw,  L_i, z,mu_12, w_it, b_it,  y_it, age_t0

Integer :: i_bin, obs_t, cbin, cbin2, pbin, pbin2, fe_bin, i_sig_eps, year0

Integer								:: Nobs_i
	Integer , allocatable, dimension(:) :: csta_, year_
!	Integer , allocatable, dimension(:) :: loci_index	! index for  current location

	Real , allocatable, dimension(:) ::   age_

!	Double Precision , allocatable, dimension(:) :: wage

	Nobs_i = dat(obs_i)%Nobs_i

!	allocate( csta_( Nobs_i), age_( Nobs_i), loci_index( Nobs_i), wage( Nobs_i), year_( Nobs_i))
	allocate( csta_( Nobs_i), age_( Nobs_i),                                     year_( Nobs_i))

	year0 = 79
	year_ = dat(obs_i)%year(1:Nobs_i) - year0
	csta_ = dat(obs_i)%csta(1:Nobs_i)
	age_  = dat(obs_i)%age (1:Nobs_i)/a0

	Pcb  = 1.0d0/dat(obs_i)%Nbins_i

	Like_iw =  0.0

	do i_sig_eps = 1, NPT_sig_eps ! transient effect normal mixture distribution
		do fe_bin = 1, NPT_fe		! fixed effect
			do i_bin = 1, dat(obs_i)%Nbins_i

					L_i = 1.0d0
					do obs_t = 1,Nobs_i

						w_it = dat(obs_i)%wage(obs_t)
!						if (w_it <= 0) cycle		! ignore missing observations, and treat zero as if the wage is missing
						b_it = Sdat(dat(obs_i)%csta(obs_t))%Ben
						y_it  = max(w_it,b_it)
						mu_12 = mu0   + q(p_mu  )*sdat(dat(obs_i)%csta(obs_t))%mu
						mu_12 = mu_12 + q(p_year)*year_(obs_t) 

						mu_12 = mu_12 + q(p_linearwage)*age_(obs_t) + q(p_quadwage)*age_(obs_t)*age_(obs_t)
						mu_12 = mu_12 + (q(p_afqt) + q(p_afqt_age)*age_(obs_t))*dat(obs_i)%afqt/ab0

						cbin  =  spt( dat(obs_i)%loci_index(obs_t),i_bin)
						z     = (y_it - mu_12 - upsilon(cbin) - eta(fe_bin) )/sig_eps(i_sig_eps)
						if (w_it + TINY2 < b_it) then
							L_i = L_i*alnorm(z, .false.) ! upper = .false. means Phi(z) rather than 1-Phi(z)
						else
							L_i = L_i*phi0*exp(-z*z/2.0d0)/sig_eps(i_sig_eps)
						end if
!						IF (ISNAN(L_i)) THEN 
!							print '(A/)', "obs_t, upsilon(cbin) , eta(fe_bin) ,sdat(dat(obs_i)%csta(obs_t))%mu,sig_eps(i_sig_eps), z,L_i"
!							print '(I7,10E15.4)', obs_t, upsilon(cbin) , eta(fe_bin) ,sdat(dat(obs_i)%csta(obs_t))%mu,sig_eps(i_sig_eps), z,L_i
!							stop
!						ENDIF ! (ISNAN(F))

					end do !obs_t		

					Like_iw = Like_iw + PP_sig_eps(i_sig_eps)*PP1(fe_bin)*Pcb(i_bin)*L_i
			end do ! i_bin
		end do ! fe_bin
	end do ! i_sig_eps 

	deallocate( csta_, age_,                   year_)

end FUNCTION Like_iw
