Subroutine EVF(age)
!	for mbr80
!   record choice probabilities for each person each year
!	allow previous location with no wage information
!	Calculate the Expected value function for parameter vector x.

! Assume that population doesn't interact with the preference shocks, to speed things up

!use nrtype; 
use mbr_vars
IMPLICIT NONE

	Integer,	intent(in)						:: age

	Integer :: i,i2,j,j2,csta,psta, obs_i, obs_t, i_bin, i_bin2, cbin, pbin, cbin2, pbin2,  Nloc_i, NPT_lm_lm_2

	Double Precision :: vscale,tval
	Double Precision, dimension(NLOC)  :: tev	

!	Double Precision, dimension(NLOC,0:NPT_lm,0:NPT_lm2,0:NLOC,0:NPT_lm,0:NPT_lm2)  :: EV !(csta,cb,cb2,psta,pb,pb2)
	Double Precision, dimension(NLOC,0:NPT_lm,0:NPT_lm2,0:NLOC,0:NPT_lm,0:NPT_lm2)  :: EV0	! local, EV next period, current type

!	v(csta,cb,cb2,psta,pb,pb2,dsta)
!	u(csta,cb,cb2,psta,       dsta)

	EV0 = BETA*EV
	NPT_lm_lm_2 = NPT_lm*NPT_lm2

! First separate the case where there is no previous location
	do csta = 1,NLOC	! current location
		j = 0  ! 0 means no previous wage information
			j2 = 0
				psta = 0			! previous location
					do i = 1,NPT_lm			! current wage bin
						do i2 = 1,NPT_lm2	! current preference bin
							v(csta,i,i2,psta,j,j2,:   ) = u(csta,i,i2,psta,:   ) + EV0(:   ,0,0,csta,i,i2) ! moving, new location
							v(csta,i,i2,psta,j,j2,csta) = u(csta,i,i2,psta,csta) + EV0(csta,i,i2,psta,j,j2)! staying
							vscale                      = maxval(v(csta,i,i2,psta,j,j2,:))
							tev					        =    exp(v(csta,i,i2,psta,j,j2,:)-vscale)
							tval				        = sum(tev)
							 v(csta,i,i2,psta,j,j2,:)   = tev/tval ! these are now the choice probabilities
							EV(csta,i,i2,psta,j,j2)     = vscale + log(tval) 
						end do ! i2
					end do ! i
					EV(csta,0,0,psta,j,j2)		        = sum(EV(csta,1:NPT_lm,1:NPT_lm2,psta,j,j2))/NPT_lm_lm_2
					! it is assumed here that the location match shocks are uniformly and independently distributed
	end do ! csta

!	forall(csta=1:NLOC,j = 0:NPT_lm,j2= 0:NPT_lm2,psta = 1:NLOC,i = 1:NPT_lm,i2 = 1:NPT_lm2,dsta = 1:NLOC)
!		v(csta,i,i2,psta,j,j2,dsta) = u(csta,i,i2,psta,dsta) + EV0(dsta,0,0,csta,i,i2) ! moving, new location
!	end forall
!	forall(csta=1:NLOC,j = 0:NPT_lm,j2= 0:NPT_lm2,psta = 1:NLOC,i = 1:NPT_lm,i2 = 1:NPT_lm2)
!		v(csta,i,i2,psta,j,j2,csta) = u(csta,i,i2,psta,csta) + EV0(csta,i,i2,psta,j,j2)! staying
!		v(csta,i,i2,psta,j,j2,psta) = u(csta,i,i2,psta,psta) + EV0(psta,j,j2,csta,i,i2)! moving, previous location
!	end forall

	do csta = 1,NLOC	! current location
		do j = 0,NPT_lm  ! 0 means no previous wage information
			do j2= 0,NPT_lm2
				do psta = 1,NLOC			! previous location
					do i = 1,NPT_lm			! current wage bin
						do i2 = 1,NPT_lm2	! current preference bin
							v(csta,i,i2,psta,j,j2,:   ) = u(csta,i,i2,psta,:   ) + EV0(:   ,0,0,csta,i,i2) ! moving, new location
							v(csta,i,i2,psta,j,j2,csta) = u(csta,i,i2,psta,csta) + EV0(csta,i,i2,psta,j,j2)! staying
							v(csta,i,i2,psta,j,j2,psta) = u(csta,i,i2,psta,psta) + EV0(psta,j,j2,csta,i,i2)! moving, previous location
!							vscale                      = maxval(v(csta,i,i2,psta,j,j2,:))
							vscale                      =        v(csta,i,i2,psta,j,j2,csta)
							tev					        =    exp(v(csta,i,i2,psta,j,j2,:)-vscale)
!							tev					        =    exp(v(csta,i,i2,psta,j,j2,:)-v(csta,i,i2,psta,j,j2,csta))
							tval				        = sum(tev)
							 v(csta,i,i2,psta,j,j2,:)   = tev/tval ! these are now the choice probabilities
							EV(csta,i,i2,psta,j,j2)     = vscale + log(tval) 
						end do ! i2
					end do ! i
					EV(csta,0,0,psta,j,j2)		        = sum(EV(csta,1:NPT_lm,1:NPT_lm2,psta,j,j2))/NPT_lm_lm_2
					! it is assumed here that the location match shocks are uniformly and independently distributed
				end do ! psta
			end do ! j2
		end do ! j
	end do ! csta

!	store the choice probabilities, for people of this age with this home location

	if (age > LAST_AGE) return ! there is no need to store the choice probabilities for ages not seen in the data 

!    print '(A100,/,8I6,2F12.5)', " obs_i, obs_t, i_bin, i_bin2, cbin, cbin2, pbin, pbin2, u, vv(obs_t,cbin,cbin2,pbin,pbin2) "

	do obs_i = 1,N_i
		if ( (ma_iloc(hloc) .ne. dat(obs_i)%iloc) .AND. (NoHome .eq. 0) ) cycle	
		Nloc_i  = dat(obs_i)%Nloc_i
!		Nbins_i = NPT_lm**Nloc_i
!		Nbins2_i = NPT_lm2**Nloc_i
		do obs_t = 1,dat(obs_i)%Nobs_i
			if ( age .ne. dat(obs_i)%age(obs_t) ) cycle	
			do i_bin = 1, dat(obs_i)%Nbins_i
				do i_bin2 = 1, dat(obs_i)%Nbins2_i
					cbin  =  spt( dat(obs_i)%loci_index(obs_t),i_bin)
					cbin2 = spt2( dat(obs_i)%loci_index(obs_t),i_bin2)
					if ( dat(obs_i)%psta(obs_t) > 0 .AND. dat(obs_i)%ploci_index(obs_t) > 0) then
						pbin  =  spt(dat(obs_i)%ploci_index(obs_t),i_bin)
						pbin2 = spt2(dat(obs_i)%ploci_index(obs_t),i_bin2)
					else
						pbin  = 0
						pbin2 = 0
					end if
					dat(obs_i)%vv(obs_t,cbin,cbin2,pbin,pbin2) = v(dat(obs_i)%csta(obs_t),cbin,cbin2,dat(obs_i)%psta(obs_t),pbin,pbin2,dat(obs_i)%dsta(obs_t))
!					print '(8I6,2F12.5)',  obs_i, obs_t, i_bin, i_bin2, cbin, cbin2, pbin, pbin2, u(dat(obs_i)%csta(obs_t),cbin,cbin2,dat(obs_i)%psta(obs_t),dat(obs_i)%dsta(obs_t)), dat(obs_i)%vv(obs_t,cbin,cbin2,pbin,pbin2)
				end do ! i_bin2
			end do ! i_bin
		end do ! obs_t
	end do !obs_i

end subroutine EVF

