Subroutine fill_miles

!use nrtype; 

use mbr_vars

IMPLICIT NONE

!	reads latlong50.dat from unit 8 to form matrix(NLOC,NLOC) of distance between locations.



	Integer  , parameter :: MAXNLOC = 50    !max # locs  

	Double Precision , parameter :: DTR = 0.017453292 !conv fac degress to radians (2pi/360)

	Double Precision , parameter :: RTD = 57.29577951 !conv fac radians to degrees



	Integer  :: i, j, n, tloc(MAXNLOC)

	Double Precision , dimension(:), allocatable :: long, lat 

	Character(Len=20), dimension(:), allocatable :: sname

	Double Precision :: dis  



!	matrix to keep track of adjacent locations



	allocate(sname(MAXNLOC))

	allocate(long(NLOC))

	allocate(lat(NLOC))



	open(Unit=8,File=latlong_fn)



	do j=1,MAXNLOC

		read(Unit=8,fmt='(I2,F8.0,F7.0,A)') tloc(j),long(j),lat(j),sname(j)

		long(j) = .0001 * DTR * long(j)  !convert deg -> radians

		lat(j)  = .0001 * DTR * lat(j)   !convert deg -> radians

	end do !j

	close(Unit=8)



	if (.not. allocated(miles)) allocate(miles(NLOC,NLOC))



	miles = 0.0  !matrix NLOC x NLOC



	do i=1,NLOC

		do j=1,NLOC

			if (i .NE. j) then

				dis = SIN(lat(i))*SIN(lat(j)) + &

					COS(lat(i))*COS(lat(j))*COS(long(i)-long(j))

!				print *,"Debug:: dis=",dis

				miles(i,j) = 69.16*ACOS(dis)*RTD  !cos returns arc dist in radians

				miles(i,j) = miles(i,j)/1000.0 !miles in (1,000s)

!				print *,"Debug:: i=",i," j=",j," miles=",miles(i,j)

			end if !i ne j

		end do !j

	end do !i



!	debug:: check mileage between state (centroids)



!	print *,"Check distance (in 1,000 of miles) between locations."  

!	print *,"Mileage matrix NLOC by NLOC matrix"

!	print *,"in Groups of 5"

!	do i=1,NLOC

!		print *,"Location = ",i

!		print '(5F12.5)',(miles(i,j), j=1,NLOC)

!		print *," "

!	end do



	deallocate(sname)

	deallocate(long)

	deallocate(lat)

end subroutine fill_miles

