SUBROUTINE read_climate()
!use nrtype
 use mbr_vars
IMPLICIT NONE

    Integer :: ios, i,k
	Double Precision, parameter :: scale1 = 0.1    !scale for temps and precip
	Double Precision, parameter :: scale2 = 0.001 !scale for degree days
    
!	open(unit=9,FILE="~/mbr61/climate.dat")
	open(unit=9,FILE=amenity_fn)


! climate data organized as
! statenum,seashore,win_temp,sum_temp,mean_temp,dsw_temp,precip,heat_dd,cool_dd,total_dd
! seashore is an indicator variable equal to 1 if the state has a seashore
! temperatures in F degrees, Winter, summer, mean and difference between summer and winter
! dd = degree days; record heating, cooling, and total degree days (baseline is 65 degrees)

    do i=1,NLOC
        read(unit=9,FMT=*,IOSTAT=ios) Sdat(i)%State_num, Sdat(i)%seashore, &
		 Sdat(i)%win_temp, Sdat(i)%sum_temp, Sdat(i)%mean_temp, Sdat(i)%dsw_temp, Sdat(i)%precip, &
		 Sdat(i)%heat_dd, Sdat(i)%cool_dd, Sdat(i)%total_dd, Sdat(i)%name, &
		 (Sdat(i)%region(k),k=1,NLOC)
        if (ios < 0) exit !do loop
    end do

!scale climate data
	Sdat(:)%win_temp  = scale1*Sdat(:)%win_temp
	Sdat(:)%sum_temp  = scale1*Sdat(:)%sum_temp
	Sdat(:)%mean_temp = scale1*Sdat(:)%mean_temp
	Sdat(:)%dsw_temp  = scale1*Sdat(:)%dsw_temp
	Sdat(:)%precip    = scale1*Sdat(:)%precip
	Sdat(:)%heat_dd   = scale2*Sdat(:)%heat_dd
	Sdat(:)%cool_dd   = scale2*Sdat(:)%cool_dd
	Sdat(:)%total_dd  = scale2*Sdat(:)%total_dd

	if (myid .eq. master) then

		print *," "
		print *,"Climate Data (scaled)"

		Print *,"             |_______Temp___________|Precip|__Degree Days______|"
		print '(A)'," State Shore   Win   Sum  Mean  Diff Precip   Heat   Cool  Total   State          Region "
		do i=1,NLOC
			write(unit=*,FMT='(2I6,4F6.1,F7.2,3F7.2,1X, A16, 50I2)') Sdat(i)%State_num,Sdat(i)%seashore, &
				Sdat(i)%win_temp,Sdat(i)%sum_temp,Sdat(i)%mean_temp,Sdat(i)%dsw_temp,Sdat(i)%precip, &
				Sdat(i)%heat_dd, Sdat(i)%cool_dd, Sdat(i)%total_dd, Sdat(i)%name, &
				(Sdat(i)%region(k),k=1,NLOC)
		end do
    end if ! (myid .eq. master)
    
    close(unit=9)
 
end subroutine read_climate