SUBROUTINE read_data
!use nrtype; 
use mbr_vars
IMPLICIT NONE

!	edited to save space (jk, Sept 6, 2007)

!  mbr93
!   DC and Delaware are treated as a parts of Maryland
!	For each person, there is a list of possible wage bins
!	The number of possibilities is NPT**Nloc_i
!		where NPT is the number of support points, 
!		and Nloc_i is the number of locations visited by this person
!	The list of locations visited is in vloci_list
!	Modified to handle nonconsecutive observations (April 20, 02)


	Integer , dimension(1:56), parameter :: statecode = &
		(/ 1, 2, 0, 3 ,4 ,5 ,0 ,6 ,7 ,8,20, 9,10, 0,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,&
		  26,27,28,29,30,31,32,33,34,35,36,37,38, 0,39,40,41,42,43,44,45,46, 0,47,48,49,50 /)

!	Integer , intent(in), dimension(:) :: loc

	Integer :: id,yr,tiloc,tbs,tps,tes,ios,n,lastid,lastyr,nobs,bs,ps,es,i,j,nr, idcount,ii
	Integer :: kflag,is,nmovers,nhome,age,minage,pflag, afqtp80, afqtp89
	Integer :: t,i_t,Nloci_,ivloc,Nloci_sofar,obs_i,Newloc, MaxLoc_i,nskip
	Integer :: Nmovei_

	Logical :: Moved

	Double Precision :: rinc1

!	Type(Record_type) , allocatable, dimension(:) :: tdat !tmp data record

	Integer , dimension(NLOC,NLOC) :: tmat

	Integer , dimension(FIRST_AGE:LAST_AGE) :: acnt

	Integer , dimension(0:MaxT_i) :: Nmoves = 0

!	Double Precision :: q_i  !probability of this wage bin history

	obs_i=0
	MaxLoc_i=0
	nskip = 0

	open(unit=7,FILE=in_fname,STATUS="OLD",IOSTAT=ios)
	if (ios /= 0) then
		print *,"Error:: Problem opening ",in_fname
		stop
	end if

	id = -1
	yr = -1
	nobs = 0
	n = 0
	Nobs_TOT = 0
	tmat = 0
	i_t = 1
	
	nr = 0

!	rough count to allocate data array

	idcount = 1
	do 
		lastyr = yr
		lastid = id
		read(unit=7,FMT=*,IOSTAT=ios) id,tiloc,yr,tbs,rinc1, tps,tes, age, afqtp80, afqtp89
		if (age == LAST_AGE) then
		    print *, "id,tiloc,yr,tbs,rinc1, tps,tes, age, afqtp80, afqtp89"
            print *,  id,tiloc,yr,tbs,rinc1, tps,tes, age, afqtp80, afqtp89
        end if ! age
		if (ios < 0) exit

		if (id .eq. lastid .and. yr > lastyr) cycle	! continuation
		
		if (id .eq. lastid .and. yr <= lastyr) then !new replica
			idcount = idcount + 1
			if (idcount > IDmax) then
				if (idcount == IDmax+1 .and. myid .eq. master) print *, "idcount > IDmax  ", "id ", id, " count ", idcount
				cycle
			end if !(idcount > IDmax) 
		end if !(id .eq. lastid .and. yr <= lastyr)

		obs_i = obs_i + 1
		if (myid .eq. master .and. obs_i > MAXREC) then
			print *, " obs_i =  ", obs_i, "Too many records (increase MAXREC)"
			stop
		end if

		if (id .NE. lastid ) then 
			idcount = 1
		end if !(id .NE. lastid)

	end do ! read loop

	close(unit=7)

	N_i = obs_i
	obs_i = 0

	if (myid .eq. master) 	print *,"allocate(dat(",N_i,")) ..."
		allocate(dat(N_i)) 
	if (myid .eq. master) 	print *,"done"

	id = -1
	yr = -1
	open(unit=7,FILE=in_fname,STATUS="OLD",IOSTAT=ios)

	idcount = 1
	do 
		lastyr = yr
!		read(unit=7,FMT=*,IOSTAT=ios) id,tiloc,yr,tbs, tps,tes,age,q_i,fe_bin,i_bin
		read(unit=7,FMT=*,IOSTAT=ios) id,tiloc,yr,tbs,rinc1, tps,tes, age, afqtp80, afqtp89
		if (ios < 0) exit
		if (id .eq. lastid .and. yr <= lastyr) then !new replica
			idcount = idcount + 1
			if (idcount > IDmax) cycle
		end if !(id .eq. lastid .and. yr <= lastyr)
		if (id .NE. lastid ) idcount = 1

		nr = nr+1  !#records read

! -------------------------------------------
! --  check the data
!  test whether observation is from one of the initial locations

		kflag = 0		! keep flag
		do j=1,NILOC  !keep observation if in master list
			if (statecode(tiloc) == ma_iloc(j)) then
				!is=initial state is runs 1..# of states used for estimation
				is = ma_iloc(j) !code on state code basis 1..51   
				kflag = 1
				exit !this do loop to to data loop
			end if
		end do

		if (kflag == 0) then
			cycle !return to top of data loop;end processing this rec 
		endif
		if (tbs == 7 .OR. tps == 7 .OR. tes == 7) cycle !invalid state codes
! state codes 3,14,43,52 are also invalid but not found in mbr10r.input.dat
!		if (id==339 .OR. id == 7058 .OR. id==7612 .OR. id == 8217) cycle

		n=n+1
!
!       treat Delaware as part of Maryland   
!		if (tbs == 10 ) tbs = 24
!		if (tps == 10 ) tps = 24
!		if (tes == 10 ) tes = 24
				
!		recode states from fips codes to consecutive location numbers
		if (tbs > 0 .and. tbs < 57) then 
			bs = statecode(tbs)
		else
			print *,"ERROR:  tbs is out of range, tbs = ",tbs
			stop
		end if

		if (bs < 1  .or. bs > NLOC) then 
			print *,"ERROR:  tbs is out of range, tbs = ",tbs, " id = ", id, " year = ", yr
			stop
		end if

		if (tps >= 0 .and. tps < 57) then
			if (tps == 0) then 
				ps = 0
			else
				ps = statecode(tps) !do not recode null (0) state
			end if
		else
			print *,"ERROR:  tps is out of range, tps = ",tps
			stop
		end if
		if (tes > 0 .and. tes < 57) then 
			es = statecode(tes)
		else
			print *,"ERROR:  tes is out of range, tes = ",tes ,"ID == ",id
			stop
		end if

! finished checking
! -----------------------------------------------------------------------------------------

!	maybe this is the first observation for this id (or for a new replica of this id)
!	or maybe it is a continuation (the next year for this id)

		if (id .NE. lastid .OR. yr <= lastyr) then !new case (or new replica if year <= lastyr) 
			if (obs_i > 0) then 
				if (obs_i > MAXREC) then
					print *, "Too many records (increase MAXREC)"
					stop
				end if
				dat(obs_i)%Nobs_i    = i_t             ! this is for the previous id
				dat(obs_i)%Nloc_i    = Nloci_          ! this is for the previous id
				dat(obs_i)%Nbins_i   = NPT_lm**Nloci_  ! this is for the previous id
				dat(obs_i)%Nbins2_i  = NPT_lm2**Nloci_ ! this is for the previous id
				MaxLoc_i = max(MaxLoc_i,Nloci_)
				dat(obs_i)%moved  = moved  
			end if ! obs_i > 0
			obs_i = obs_i + 1
			lastid = id
!			dat(obs_i)%id            = id
			dat(obs_i)%iloc          = is	! home location
			dat(obs_i)%afqt          = afqtp80
			dat(obs_i)%vloci_list(1) = bs
			Nloci_ = 1
			i_t    = 1
			moved  = .FALSE.
			Nobs_TOT = Nobs_TOT + 1
			dat(obs_i)%loci_index(i_t)    = Nloci_
			dat(obs_i)%vloci_list(Nloci_) = bs

		else

			Nobs_TOT = Nobs_TOT + 1
			i_t = i_t + 1
			Nloci_sofar = Nloci_
			Newloc = 1
			do ivloc = 1,Nloci_sofar
				if(bs .EQ. dat(obs_i)%vloci_list(ivloc) ) then 
					dat(obs_i)%loci_index(i_t) = ivloc
					Newloc = 0
					exit ! do ivloc
				end if ! (bs)
			end do ! ivloc

			if (Newloc == 1) then
					Nloci_ = Nloci_ + 1
					if (Nloci_ > MvLoc) then
						print *, "Too many locations (increase MvLoc)"
						print *, "id ",id, " locations ", (dat(obs_i)%vloci_list(ii),ii=1,MvLoc)
						stop
					end if
					dat(obs_i)%loci_index(i_t)		= Nloci_
					dat(obs_i)%vloci_list(Nloci_)	= bs
			end if

			if (moved .eqv. .TRUE. .AND. ps > 0) then ! this means that wage information for previous locations seen before a move will be ignored by the likelihood routine
				pflag = 1
				do ivloc = 1,Nloci_sofar
					if(ps .EQ. dat(obs_i)%vloci_list(ivloc) ) then 
						dat(obs_i)%ploci_index(i_t) = ivloc
						pflag=0
						exit ! do ivloc
					end if ! (ps)
				end do ! ivloc
!				if (pflag == 1) then 
!					print *, "previous location not found: id,bs,ps = ", id,tbs,tps
!				end if 
			end if ! (ps > 0)
		end if	! id

		if ( bs .NE. es)	moved = .TRUE.

		dat(obs_i)%year(i_t)  = yr 
		dat(obs_i)%age(i_t)   = age   
		dat(obs_i)%csta(i_t)  = bs  
		dat(obs_i)%psta(i_t)  = ps  
		dat(obs_i)%dsta(i_t)  = es  
		dat(obs_i)%wage(i_t) = rinc1/IFAC

		tmat(bs,es) = tmat(bs,es) + 1

		if (nr>n+nskip) then
			nskip = nr - n
!			print * , "skipping observation prior to id = ",id, "  year = ", yr
		end if

	end do ! read loop
	close(unit=7)

	dat(obs_i)%Nobs_i	 = i_t    ! this is for the last id
	dat(obs_i)%Nloc_i	 = Nloci_ ! this is for the last id
	dat(obs_i)%Nbins_i  = NPT_lm**Nloci_  ! this is for the previous id
	dat(obs_i)%Nbins2_i = NPT_lm2**Nloci_ ! this is for the previous id
	MaxLoc_i			 = max(MaxLoc_i,Nloci_)
	dat(obs_i)%moved    = moved  
	
	N_i = obs_i   ! number of individuals
!	Nobs_TOT = n  ! number of observations (person-years)
      

! ----------------------------------------------------------
! summary statistics

	nhome   = 0
	nmovers = 0
	minage = 99
	maxage =  1
	acnt(FIRST_AGE:LAST_AGE) = 0  

	if (myid .eq. master) then
		print *," "
		print *,"    Number of lines read:           ",nr
		print *,"    Number of cases (respondents):  ",N_i
		print *,"    Number of person-years       :  ",Nobs_TOT
		print *," "
		print '(A,I7)',    "Maximal number of locations visited:",MaxLoc_i
		print *," "

		print *, " "
		print *, "Movers (First 250) "
		print *, "    home from   to   miles previous adjacent age pop(dest)"
	end if ! master

	do i=1,N_i
		Nmovei_ = 0
		do t = 1, dat(i)%Nobs_i
			age = dat(i)%age(t) 
			minage = min(minage,age)
			maxage = max(maxage,age)
			if (age .GE. FIRST_AGE .AND. age .LE. LAST_AGE) acnt(age)=acnt(age)+1

			if (dat(i)%csta(t) .NE. dat(i)%dsta(t)) then
				nmovers = nmovers+1
				Nmovei_ = Nmovei_ +1
!				id = dat(i)%id
				is = dat(i)%iloc
				bs = dat(i)%csta(t)
				es = dat(i)%dsta(t)
				ps = dat(i)%psta(t)
				if (es .eq. is) then !both on statecode basis
					nhome = nhome +1
				end if
				if (myid .eq. master ) then
					if (nmovers < 251) then
    					print '(3I5,f8.4,I9,I8,I5,f10.5)', dat(i)%iloc,bs,es,miles(bs,es),ps,adjacent(bs,es),age,Sdat(es)%pop
    				end if ! nmovers
					if (age == LAST_AGE) then
    					print '(6I5,I9,I8,I5,f10.5)', i,t,dat(i)%year(t), dat(i)%iloc,bs,es,ps,adjacent(bs,es),age
       				end if ! age
				end if ! master
			end if
		end do ! t 
		Nmoves(Nmovei_) = Nmoves(Nmovei_) + 1
	end do ! i

!	if (myid .eq. master) then
!		print *," "
!		print '(A,f10.1)', "excluded wage observations: cutoff = ", IFAC*w00
!		print *, "    id home csta year      wage"
!		do i=1,N_i
!			do t = 1, dat(i)%Nobs_i
!				if (dat(i)%wage(t) < w00) then
!					print '(3I5,f10.5)',  dat(i)%iloc,dat(i)%csta(t),t,dat(i)%wage(t)
!				end if
!			end do ! t 
!		end do ! i
!	end if ! master

	if (myid .eq. master) then
		print *," "
		print '(A,I7)',    " Number of moves: ", nmovers
		print '(A,f7.2,A)'," Migration rate : ",100.0*nmovers/Nobs_TOT,"%"
		print *," "
		print *,"Number of moves home: ",nhome
		print *," "

		print *,"  Move  Counts"
		print '(I5,I10)',(i,Nmoves(i),i=0,MaxT_i)
		print *," "

		print '(A,I7)',    "    Number of people who ever moved:",N_i-Nmoves(0)
		print '(A,f7.2,A)',"Percentage of people who ever moved:",100.0*(1-Nmoves(0)/N_i),"%"
		print *," "
	
		print *,"Age distribution."
		print *,"  Age     Count"
		print '(I5,I10,f8.2,A)',(i,acnt(i),100.0*acnt(i)/sum(acnt),"%",i=FIRST_AGE,LAST_AGE)
		print *," "
		
		print *,"Minimum age= ",minage
		print *,"Maximum age= ",maxage
		print *," "
	end if ! master

end SUBROUTINE read_data
