Subroutine Slave_work !function evaluation assigned to slave

! for mbr83W

!receive info (hloc,q) from master calculate elements of L0, f0

use mpi
use mbr_vars
IMPLICIT NONE

Interface
   Subroutine UTIL(x,h,age,itype)
     use mbr_vars
     IMPLICIT NONE
     Double Precision, intent(in), dimension(NPARMS)  :: x
     Integer , intent(in)                             :: h, age, itype
   End Subroutine UTIL
End Interface

Interface
   Subroutine EVF(age)
     use mbr_vars
     IMPLICIT NONE
     Integer , intent(in)                              :: age
   end Subroutine EVF
end Interface

Interface
   Function Like_i(obs_i)
     use mbr_vars
     IMPLICIT NONE
     Integer , intent(in) :: obs_i
     Double Precision :: Like_i
   End Function Like_i
end Interface


	Integer :: itype,age,nnn,ierr,obs_i,nnzero, flag, fe_bin, i, i_fe ,i_parm

	Integer :: status(MPI_STATUS_SIZE)
	Double Precision :: loopb, loope, ct1,ct2, ct1a !timing values
	Double Precision , allocatable, dimension(:)   :: tL0,tL00

	Double Precision :: LL_ip

	Character(Len=8)		:: date
	Character(Len=10)		:: time
	Character(Len=5)		:: zone
	Integer , dimension(8)	:: tvim
	
	
	if (.not. allocated(tL0) ) allocate(tL0(N_i))
	if (.not. allocated(tL00)) allocate(tL00(N_i))

	allocate( v(NLOC,NPT_lm,NPT_lm2,0:NLOC,0:NPT_lm,0:NPT_lm2,NLOC)) 	!(csta,cb,cb2,psta,pb,pb2,dsta)

flag = 1

do 
   tL0  = 0.0d0
   
	CALL MPI_RECV(hloc,1,MPI_INTEGER,master,0,MPI_COMM_WORLD,status,ierr)

   if (hloc == 0) then !new value for q, ptype
      CALL MPI_RECV(    q,NPARMS,MPI_DOUBLE_PRECISION,master,0,MPI_COMM_WORLD,status,ierr)
      CALL MPI_RECV(ptype,     3,MPI_DOUBLE_PRECISION,master,0,MPI_COMM_WORLD,status,ierr)
      CALL MPI_RECV( hloc,     1,MPI_INTEGER         ,master,0,MPI_COMM_WORLD,status,ierr) !value of hloc
!		print '(A10,I4,A10,I5,A12,F12.3,A10)',"rank = ", myid, "home = ",hloc
      
   else if (hloc == -1) then
      exit !do; receive -1 after convergence
   end if !hloc

! have hloc defined - calculate contribution to log likelihood and score vector
! for observations with this hloc.

	if (NPT_lm > 3 ) then
		print *, "this program assumes the location match wage distribution has less than 3 support points"
		stop 
	end if
	upsilon(1) = -abs(q(p_sigups))
	do i = 2, NPT_lm
		upsilon(i) = upsilon(1) *(NPT_lm - 1 - i)
	end do ! i
	if (NPT_lm2 > 3 ) then
		print *, "this program assumes the location preference match distribution has less than 3 support points"
		stop 
	end if
	upsilon2(1) = -abs(q(p_sigups2))
	do i = 2, NPT_lm2
		upsilon2(i) = upsilon2(1) *(NPT_lm2 - 1 - i)
	end do ! i

	mu0        = q(p_meanwage)
	sig_eps(1) = abs(q(p_sigeps1))
	sig_eps(2) = abs(q(p_sigeps2))
	sig_eps(3) = abs(q(p_sigeps3))
	sig_eps(4) = abs(q(p_sigeps4))

	i_fe   = 1
	i_parm = p_eta1
	do
		eta(i_fe)   = -abs(q(i_parm ))
		eta(i_fe+1) = 0 
		eta(NPT_fe+1-i_fe) = -eta(i_fe)
		if (2*i_fe+1==NPT_fe) exit
		i_fe   = i_fe + 1
		i_parm = i_parm + 1
	end do

   loopb = MPI_WTIME() !beginning of loop

	do itype=1,Ntype-1

		if (ptype(itype) < TINY) cycle
		tL00 = 0.0d0
		EV = 0.0d0
		do age=CAP_AGE,FIRST_AGE,-1
!			loopb = MPI_WTIME()
			CALL UTIL(q,hloc,age,itype) !calculates one period util flow
!			loope = MPI_WTIME()
!			if (age == CAP_AGE) print '(A10,I4,A10,I5,A12,F12.3,A10)',"Util:  rank = ", myid, "home = ",hloc,  "MPI_Wtime ", loope-loopb ," seconds"
!			loopb = MPI_WTIME()
			CALL EVF(age) !calculates choice probabilities
!			loope = MPI_WTIME()
!			if (age == CAP_AGE) print '(A10,I4,A10,I5,A12,F12.3,A10)',"EVF :  rank = ", myid, "home = ",hloc,  "MPI_Wtime ", loope-loopb ," seconds"
		end do !age	

		if (flag .eq. 1) then 
			print *,"rank = ", myid," home = ",ma_iloc(hloc), " type ", itype
			print '(A,9F9.6)',"v(ma_iloc(hloc),1:k1,0,0,20,ma_iloc(hloc)) ", v(ma_iloc(hloc),1:NPT_lm,1:NPT_lm2,0,0,0,ma_iloc(hloc))
			flag = 0
		end if !(flag .eq. 1)

			do obs_i = 1,N_i
!				for each observation, compute the likelihood function if the home location is hloc
!				o.w., ignore the observation (it will be picked up elsewhere)
				if ( (ma_iloc(hloc) .ne. dat(obs_i)%iloc) .AND. (NoHome .eq. 0) ) cycle	
				LL_ip = Like_i(obs_i)
				tL00(obs_i) = tL00(obs_i) + LL_ip
				tL0(obs_i)  =  tL0(obs_i) + ptype(itype)*LL_ip
			end do !obs_i

		CALL MPI_SEND(tL00,N_i,MPI_DOUBLE_PRECISION,master,itype,MPI_COMM_WORLD,ierr)		
	end do !itype

   loope = MPI_WTIME()

!	print '(A10,I4,A10,I5,A12,F12.3,A10)',"rank = ", myid, "home = ",hloc,  "MPI_Wtime ", loope-loopb ," seconds"

!	do obs_i = 1,N_i
!		if ( (ma_iloc(hloc) .ne. dat(obs_i)%iloc) .AND. (NoHome .eq. 0) ) cycle	
!		print '(A10,I4,A10,I5,A7,I9,A10,I5,A15,I5,A10,I5,A12,F12.4)',"rank = ", myid, "obs_i = ",obs_i, "id = ",  dat(obs_i)%id, "iloc = ", dat(obs_i)%iloc, "ma_iloc(hloc) = ",ma_iloc(hloc), "NoHome = ", NoHome, "Likelihood ", tL0(obs_i)
!	end do !obs_i

! send information back to function (only when told to do so)

	CALL MPI_SEND( tL0,N_i,MPI_DOUBLE_PRECISION, master, 0, MPI_COMM_WORLD,ierr)

    plflag = 0 

end do !

end subroutine Slave_work
