SUBROUTINE start_values
use mbr_vars
IMPLICIT NONE

	Integer :: ss1, i, j, k

	j = 1

	p_cost1			= j		!	1	
!	label(j) = "cost, type 1"
	j = j + 1
	p_distance		= j		!	2	distance
	j = j + 1
	p_adjacent		= j		!	3	adjacent location moving cost discount
	j = j + 1
	p_home			= j		!	4	home premium
	j = j + 1
	p_previous		= j		!	5	previous location moving cost discount
	j = j + 1
	p_age			= j		!	6	age (effect on moving cost)
	j = j + 1
	p_pop			= j		!	7	population (effect on moving cost)
	j = j + 1
	p_cool			= j		!	8	cooling 
	j = j + 1
	p_heat			= j		!	9	heating
	j = j + 1
	p_income		= j 	!	10	income
	j = j + 1

	p_meanwage		= j 	!	11	mean wage
	j = j + 1
	p_mu			= j	!		12	State mean (p_mu = 1 in the model)
	j = j + 1
	p_year			= j	!		13	time trend
	j = j + 1
	p_linearwage	= j 	!	14	linear    age effect on wages
	j = j + 1
	p_quadwage		= j 	!	15	quadratic age effect on wages
	j = j + 1
	p_afqt			= j		!	16	afqt effect on wages
	j = j + 1
	p_afqt_age		= j		!	17	interaction of age and afqt
	j = j + 1
	p_sigups		= j 	!	18	standard deviation, location match (wage)
	j = j + 1
	p_sigeps1		= j 	!	19	standard deviation, transient component 1
	if (NPT_sig_eps > 1)		j = j + 1
	p_sigeps2		= j	!		20 standard deviation, transient component 2
	if (NPT_sig_eps > 2)		j = j + 1
	p_sigeps3		= j	!		21 standard deviation, transient component 3
	if (NPT_sig_eps > 3)		j = j + 1
	p_sigeps4		= j	!		22 standard deviation, transient component 4
	j = j + 1

	p_eta1			= j 	!	23	fixed effect support point
	j = j + 1
	p_eta2			= j 	!	24	fixed effect support point
	j = j + 1
	p_eta3			= j 	!	25	fixed effect support point
	j = j + 1
	p_sigups2		= j 	!	26	standard deviation, location match (preference)
	j = j + 1

	p_cost3			= j 	!	27	cost type 3
	j = j + 1
	p_cost2			= j 	!	28	cost type 2
	j = j + 1
	p_sea			= j 	!	29	sea
	j = j + 1
	p_rain			= j 	!	30	precip
	j = j + 1
	p_degdays		= j 	!	31	degree days
	do k = 1,NLOC
    	j = j + 1
	    p_region(k)		= j 	!	32-81	Region 1-50
	end do ! k
	j = j + 1
	p_pop_pref		= j 	!	82	population (preference parameter)
	j = j + 1
	p_movehome		= j 	!	83	reduced cost of moving home
	j = j + 1
	p_homedistance	= j 	!	84	distance from home (utility flow)
	j = j + 1
	p_probtype2		= j 	!	85	probability of type 2
	j = j + 1
	p_probtype3		= j 	!	86	probability of type 3 (stayer probability)


	costtype(1) = p_cost1		! moving cost parameters by type
	costtype(2) = p_cost2
	costtype(3) = p_cost3

	probtype(2) = NPARMS-1	! type probability parameters at the end of the parameter vector
	probtype(3) = NPARMS
	probtype(1) = 0		! not used

!  three types
	ss1      = ss(probtype(2)) + ss(probtype(3))

	ptype(1) = 1 - q(probtype(2)) - q(probtype(3))

if (myid .eq. master) then

	print *," "

	print *,"Starting Values (1 if estimated)"

	print *," "
	print '(I2,1X,A,F10.5)'   ,ss(p_cost1),    "Moving cost, Type 1:            ",q(p_cost1)
	print '(I2,1X,A,F10.5)'   ,ss(p_distance),    "Distance effect on moving cost: ",q(p_distance)
	print '(I2,1X,A,F10.5)'   ,ss(p_adjacent),    "Adj loc discount moving cost:   ",q(p_adjacent)
	print '(I2,1X,A,F10.5)'   ,ss(p_home),    "Home premium:                   ",q(p_home)
	print '(I2,1X,A,F10.5)'   ,ss(p_previous),   "Prev loc discount moving cost:  ",q(p_previous)
	print '(I2,1X,A,F10.5)'   ,ss(p_age),   "Age effect on moving cost:      ",q(p_age)
	print '(I2,1X,A,F10.5)'   ,ss(p_pop),   "Pop effect on moving cost:      ",q(p_pop)
	print '(I2,1X,A,3x,F10.8)',ss(probtype(3)),   "Probability of Type 3:          ",q(probtype(3))
	print '(I2,1X,A,F10.5)'   ,ss(p_cool),   "Cooling degree-days          :  ",q(p_cool)
	print '(I2,1X,A,F10.5)'   ,ss(p_heat),   "Heating degree-days          :  ",q(p_heat)
	print '(I2,1X,A,3x,F10.8)',ss(p_income),    "Income coefficient:             ",q(p_income)
	print '(I2,1X,A,F10.5)'   ,ss(p_cost3),   "Moving cost, Type 3:            ",q(p_cost3)
	print '(I2,1X,A,F10.5)'   ,ss(p_pop_pref),    "Pop parameter (pref shock):     ",q(p_pop_pref)
	print '(I2,1X,A,F10.5)'   ,ss(p_movehome),    "Home loc discount moving cost:  ",q(p_movehome)
	print '(I2,1X,A,F10.5)'   ,ss(p_homedistance),    "Distance from home:             ",q(p_homedistance)
	print '(I2,1X,A,3x,F10.8)',ss1  ,    "Probability of Type 1:          ",ptype(1)
	print '(I2,1X,A,3x,F10.8)',ss(probtype(2)),   "Probability of Type 2:          ",q(probtype(2))
	print '(I2,1X,A,F10.5)'   ,ss(p_cost2),   "Moving cost, Type 2:            ",q(p_cost2)
	print '(I2,1X,A,F10.5)'   ,ss(p_sea),   "Seashore                     :  ",q(p_sea)
	print '(I2,1X,A,F10.5)'   ,ss(p_rain),   "Precipitation                :  ",q(p_rain)
	print '(I2,1X,A,F10.5)'   ,ss(p_degdays),   "Total degree-days            :  ",q(p_degdays)

	print *," "
	print *,"Region Dummies "

	do k = 1,NLOC
    	print '(I2,1X,A,I3, A,F10.5)',ss(p_region(k)),   "Region ", k, "                 :  ",q(p_region(k))
	end do ! k

	print *," "

	print '(I2,1X,A,F10.5)'   ,ss(p_meanwage),   "Mean:                                                      ",q(p_meanwage)
	j = p_mu
	print '(I2,1X,A,F10.5)'   ,ss(j),            "      State mean (p_mu = 1 in the model)                   ",q(j)
	j = p_year
	print '(I2,1X,A,F10.5)'   ,ss(j),            "                              time trend                   ",q(j)
	print '(I2,1X,A,F10.5)'   ,ss(p_linearwage), "Linear effect of Age (on wage offers)                      ",q(p_linearwage)
	print '(I2,1X,A,F10.5)'   ,ss(p_quadwage),   "Quadratic effect of Age (on wage offers)                   ",q(p_quadwage)
	j = p_afqt
	print '(I2,1X,A,F10.5)'   ,ss(j),            "AFQT effect (on wage offers)                               ",q(j)
	j = p_afqt_age
	print '(I2,1X,A,F10.5)'   ,ss(j),            "Interaction of AFQT and age (wage offers)                  ",q(j)
	j = p_sigeps1
	do i = 1, NPT_sig_eps
		print '(I2,1X,A,I2,A,F10.5)',ss(j+i-1),        "Standard deviation,transient wage component ",i, ":            ",q(j+i-1)
	end do ! i
	print '(I2,1X,A,F10.5)'   ,ss(p_sigups),     "Standard deviation, location match component (wage):       ",q(p_sigups)
	print '(I2,1X,A,F10.5)'   ,ss(p_sigups2),    "Standard deviation, location match component (preference): ",q(p_sigups2)
	print *," "

	do i = 1, NPT_fe_par
		print '(I2,1X,A,I2,A,F10.5)',ss(p_eta1+i-1), "Support point, individual fixed effect ",i,":                 ",q(p_eta1+i-1)
	end do ! i

	print *," "

end if ! (myid .eq. master)

end subroutine start_values
