SUBROUTINE UTIL(x,h,age,itype)

!   for mbr83W
!	compute the utility flow, u(csta,cb,cb2,psta,dsta)
!	u depends on home location, but this is held fixed

use mbr_vars
IMPLICIT NONE

Interface
	FUNCTION alnorm( x, upper ) RESULT( fn_val )
		IMPLICIT NONE
		Double Precision, INTENT(IN)	::  x
		LOGICAL,   INTENT(IN)			::  upper
		Double Precision				::  fn_val
	end Function alnorm
end Interface

	Double Precision, intent(in), dimension(NPARMS) :: x
	Integer, intent(in)								:: age, itype, h

	Integer :: csta,  i,  dsta, i2
	Double Precision :: x_age, fcost

	Double Precision , dimension(NLOC,NPT_lm)	:: uu
	Double Precision , dimension(NLOC)			:: x_pop,amenity,x_miles
	Double Precision , dimension(NLOC,NLOC)		:: mcost



!	do i=1,NLOC 
!		do i2=1,NPT_lm
!			uu(i,i2) = x(p_income)*(Sdat(i)%mu + upsilon(i2))
!		end do ! i2
!	end do ! i

	do i=1,NLOC 
		uu(i,:)  = x(p_income)*Sdat(i)%mu
	end do ! i
	do i2=1,NPT_lm
		uu(:,i2) = x(p_income)*upsilon(i2) + uu(:,i2)
	end do ! i2

	x_age    = x(p_age)*age
	x_pop    = x(p_pop)*Sdat(:)%pop
	mcost     = x(p_distance)*miles(:,:) - x(p_adjacent)*adjacent(:,:)	! cheaper to move to an adjacent location
	x_miles   = x(p_homedistance)*miles(:,ma_iloc(h))				! utility flow is decreasing with distance from home
	amenity   = x(p_sea)*Sdat(:)%seashore + x(p_rain)*Sdat(:)%precip + x(p_degdays)*Sdat(:)%total_dd + x(p_cool)*Sdat(:)%cool_dd + x(p_heat)*Sdat(:)%heat_dd 
    do i2 = 1,NLOC
        amenity   = amenity + x(p_region(i2))*Sdat(:)%region(i2) 
    end do ! i2 
	fcost     = x(costtype(itype))	! type-specific moving cost 

	do csta = 1,NLOC
		do i = 1,NPT_lm
			do i2 = 1,NPT_lm2
				u(csta,i,i2,:,:) = uu(csta,i) + upsilon2(i2) + amenity(csta) - x_miles(csta) ! wages and climate and preference shocks affect current utility flow no matter what destination is chosen
			end do ! i2
		end do ! i
	end do !csta

	u = u - x_age - fcost	! moving cost increases with age

	if (abs(x(p_movehome)) .GT. TINY) then
		u(:,:,:,:,ma_iloc(h)) = u(:,:,:,:,ma_iloc(h)) + x(p_movehome)	! reduced cost of moving to home location
	end if

	do dsta = 1,NLOC
		do csta = 1,NLOC
			u(csta,:,:,dsta,dsta) = u(csta,:,:,dsta,dsta) + x(p_previous)		 					! reduced cost of moving to previous location
			u(csta,:,:,:   ,dsta) = u(csta,:,:,:   ,dsta) + x_pop(dsta) - mcost(csta,dsta)	! reduced cost of moving to large    location
		end do !csta
	end do !dsta

	do csta = 1,NLOC
		do i = 1,NPT_lm
			do i2 = 1,NPT_lm2
				u(csta,i,i2,:,csta) = uu(csta,i) + upsilon2(i2) + amenity(csta) - x_miles(csta) ! no move: delete all moving costs
			end do ! i2
		end do ! i
	end do !csta

	u(ma_iloc(h),:,:,:,:) = u(ma_iloc(h),:,:,:,:) + x(p_home)	! home premium
end subroutine UTIL
